package cn.iocoder.yudao.module.erp.service.autocode;

import cn.iocoder.yudao.module.erp.controller.admin.autocode.vo.*;
import cn.iocoder.yudao.module.erp.dal.dataobject.autocode.AutocodeRecordDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

import javax.validation.Valid;
import java.util.List;

/**
 * 编码生成记录 Service 接口
 *
 * @author 内蒙必硕
 */
public interface AutocodeRecordService {

    /**
     * 创建编码生成记录
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createAutocodeRecord(@Valid AutocodeRecordSaveReqVO createReqVO);

    /**
     * 更新编码生成记录
     *
     * @param updateReqVO 更新信息
     */
    void updateAutocodeRecord(@Valid AutocodeRecordSaveReqVO updateReqVO);

    /**
     * 删除编码生成记录
     *
     * @param id 编号
     */
    void deleteAutocodeRecord(Long id);

    /**
     * 获得编码生成记录
     *
     * @param id 编号
     * @return 编码生成记录
     */
    AutocodeRecordDO getAutocodeRecord(Long id);

    /**
     * 获得编码生成记录分页
     *
     * @param pageReqVO 分页查询
     * @return 编码生成记录分页
     */
    PageResult<AutocodeRecordDO> getAutocodeRecordPage(AutocodeRecordPageReqVO pageReqVO);
    List<AutocodeRecordDO> selectListByRuleId(Long ruleId);


    List<AutocodeRecordDO> list(AutocodeRecordDO sysAutoCodeResult);
}